;******************************************************************************
;  *   	@MCU   	   	   	   	 : MC30P6080
;  *   	@Create Date         : 2020.01.17
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@֧QQȺ   	   	  : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/   	 
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *   	   	   	   	   	P10½شP12תһ       	   	   	
;******************************************************************************
#include "MC30P6080.inc"

cblock 0x0010
abuf
statusbuf
endc

    org     0x03ff
   	goto    MAIN

    org	    0x8
   	GOTO   	INT_ISR

INT_ISR:
   	movra   abuf
   	swapar  STATUS
   	movra   statusbuf

   	JBSET 	INTIF
   	GOTO   	INTIFEND
   	JBSET  	INTIE
   	GOTO   	INTIFEND
    MOVAI   00000100B
    XORRA   P1         ;P12ת
   	BCLR   	INTIF
INTIFEND:

   	swapar  statusbuf
   	movra   STATUS
   	swapr   abuf
   	swapar  abuf
END_OF_INTERRUPT
   	RETIE  	


MAIN:
   	CALL   	SYS_INIT
   	RETURN 	
; exit point of MAIN


SYS_INIT:
   	BCLR   	GIE
   	CALL   	CLR_RAM
   	CALL   	IO_INIT
   	CALL   	INT_INIT
   	BSET   	GIE
   	RETURN 	
; exit point of SYS_INIT

INT_INIT:
   	CLRR   	T0CR            ;½ش
   	MOVAI  	0x01
   	MOVRA  	DDR1
   	MOVAI  	0xfe
   	MOVRA  	PUCON
   	BSET   	EIS             ;ⲿжԴЧ
   	BSET   	INTIE           ;ⲿжʹ
   	RETURN 	
; exit point of INT_INIT


IO_INIT:
   	CLRR   	P0
   	CLRR   	P1
   	CLRR   	DDR0
   	CLRR   	DDR1            ;1:input 0:output
   	MOVAI  	0xff
   	MOVRA  	PDCON
   	MOVRA  	PUCON           ;0:Effective 1:invalid
   	RETURN 	
; exit point of IO_INIT

CLR_RAM:
   	movai 0x40
   	movra FSR
   	movai 48
   	movra 0x07
   	decr FSR
   	clrr INDF
   	djzr 0x07
   	goto $ -3
   	clrr 0x07
   	RETURN 	
; exit point of _CLR_RAM

   	end

