;******************************************************************************
;  *   	@MCU   	   	   	   	 : MC30P6080
;  *   	@Create Date         : 2020.01.17
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@֧QQȺ   	  : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/   	 
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *   	   	   	PWM P10P11P12Ƶ100Kռձ50%     	   	   	
;******************************************************************************
#include "MC30P6080.inc"


cblock 0x0010
abuf
statusbuf

endc

    
    org     0x03ff
   	goto    MAIN

    org	    0x8
   	GOTO   	INT_ISR

INT_ISR:
   	movra   abuf
   	swapar  STATUS
   	movra   statusbuf

   	swapar  statusbuf
   	movra   STATUS
   	swapr   abuf
   	swapar  abuf
   ;END_OF_INTERRUPT
   	RETIE  	
 

MAIN:
   	CALL   	SYS_INIT
   	RETURN 	
 ; exit point of MAIN

SYS_INIT:
   	BCLR   	GIE
   	CALL   	CLR_RAM
   	CALL   	IO_INIT
   	CALL   	PWM_INIT
   	BSET   	GIE
   	RETURN 	
 ; exit point of SYS_INIT
 
PWM_INIT:
   	MOVAI  	79
   	MOVRA  	T1CNT
   	MOVRA  	T1LOAD
   	MOVAI  	40
   	MOVRA  	T1DAT0
   	MOVRA  	T1DAT1
   	MOVRA  	T1DAT2          ;ռձ50%
   	MOVAI  	0x63
   	MOVRA  	PWMCR

   	MOVAI  	0xc0
   	MOVRA  	T1CR
   	RETURN 	
 ; exit point of PWM_INIT

IO_INIT:
   	CLRR   	P0
   	CLRR   	P1
   	CLRR   	DDR0
   	CLRR   	DDR1
   	MOVAI  	0xff
   	MOVRA  	PDCON
   	MOVRA  	PUCON           ;0:Effective 1:invalid
   	RETURN 	
 ; exit point of IO_INIT

CLR_RAM:
   	movai 0x40
   	movra FSR
   	movai 48
   	movra 0x07
   	decr FSR
   	clrr INDF
   	djzr 0x07
   	goto $ -3
   	clrr 0x07
   	RETURN 	
 ; exit point of CLR_RAM

   	end


