;******************************************************************************
;  *   	@MCU   	   	   	   	 : MC30P6080
;  *   	@Create Date         : 2020.01.17
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@֧QQȺ   	   	  : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/   	 
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *   	   	   	T0 2S P12תһΣ     	   	   	
;******************************************************************************

#include "MC30P6080.inc"

cblock 0x0010
abuf
statusbuf


endc

    
    org     0x03ff
   	goto    MAIN

    org	    0x8
   	GOTO   	INT_ISR

INT_ISR:

   	movra  	abuf
   	swapar 	STATUS
   	movra  	statusbuf

   	JBSET  	T0IF
   	GOTO   	T0END
   	JBSET  	T0IE
   	GOTO   	T0END
   	BCLR   	T0IF
T0END:

   	swapar 	statusbuf
   	movra  	STATUS
   	swapr  	abuf
   	swapar 	abuf
END_OF_INTERRUPT
   	RETIE  	


MAIN:
   	CALL   	SYS_INIT
SLEEP_LOOP
   	BCLR   	GIE         ;رж
   	NOP
   	NOP
   	STOP                ;
   	NOP
   	NOP
   	BSET   	GIE         ;ж
    MOVAI   00000100B
    XORRA   P1         ;P12ת  	   	
   	GOTO   	SLEEP_LOOP
   	RETURN 	
; exit point of MAIN


SYS_INIT:
   	BCLR   	GIE
   	CALL   	CLR_RAM
   	CALL   	IO_INIT
   	CALL   	TIMER0_RTC_INIT   
   	BSET   	GIE
   	RETURN 	
; exit point of SYS_INIT

TIMER0_RTC_INIT:
   	BSET   	TBS         ;RTCΪT0ʱԴ
   	MOVAI  	0x07
   	MOVRA  	T0CR        ;ʱΪCPUʱ    ʱ256Ƶ
   	BSET   	T0IE
   	RETURN 	
; exit point of TIMER0_RTC_INIT

IO_INIT:   	   	
   	CLRR   	P0
   	CLRR   	P1
   	CLRR    DDR0       	   	
   	CLRR   	DDR1       ;1:input 0:output
   	MOVAI  	0xff
   	MOVRA  	PDCON
   	MOVRA  	PUCON      ;0:Effective 1:invalid 
   	RETURN 	
; exit point of IO_INIT

CLR_RAM:       	
   	movai 0x40
   	movra FSR
   	movai 48
   	movra 0x07
   	decr FSR
   	clrr INDF
   	djzr 0x07
   	goto $-3
   	clrr 0x07
   	RETURN 	
; exit point of CLR_RAM
   	end


