;******************************************************************************
;  *   	@MCU   	   	   	   	 : MC30P6080
;  *   	@Create Date         : 2020.01.17
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@֧QQȺ   	   	  : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/   	 
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *   	   	   	T0 5000msһ   ҪP10жϻ
;   	   	   	   	ѺP11ת   	   	   	
;******************************************************************************

#include "MC30P6080.inc"

cblock 0x0010
abuf
statusbuf
TIMER0_COUNT1
TIMER0_COUNT1_H
flag1


endc
#define     FLAG_TIMER0_5000ms   flag1,0
    
    org     0x03ff
   	goto    MAIN

    org	    0x8
   	GOTO   	INT_ISR
INT_ISR:
   	movra   abuf
   	swapar  STATUS
   	movra   statusbuf

   	JBSET  	T0IE
   	GOTO   	T0END
   	JBSET  	T0IF
   	GOTO   	T0END
   	BCLR   	T0IF
   	MOVAI  	0x83
   	MOVRA  	T0CNT

   	INCR   	TIMER0_COUNT1
   	JBCLR  	STATUS,2
   	INCR   	TIMER0_COUNT1 + 1
   	MOVAI  	0x13
   	RSUBAR 	TIMER0_COUNT1 + 1
   	JBSET  	STATUS,2
   	GOTO   	T0_H
   	MOVAI  	0x88
   	RSUBAR 	TIMER0_COUNT1
T0_H:
   	JBSET  	STATUS,0
   	GOTO   	T0END
   	CLRR   	TIMER0_COUNT1
   	CLRR   	TIMER0_COUNT1 + 1  	   	   	
   	BSET   	FLAG_TIMER0_5000ms
T0END:
   	   	
   	JBSET  	T1IE
   	GOTO   	T1END
   	JBSET  	T1IF
   	GOTO   	T1END
   	
   	   	
   	BCLR   	T1IF   	

    MOVAI   00000010B
    XORRA   P1         ;P11ת
   	
T1END:
   	
   	swapar 	statusbuf
   	movra  	STATUS
   	swapr  	abuf
   	swapar  abuf

   	RETIE  	


MAIN:
   	CALL   	SYS_INIT

SLEEP_LOOP:
   	JBSET  	FLAG_TIMER0_5000ms
   	GOTO   	SLEEP_LOOP
   	BCLR   	FLAG_TIMER0_5000ms
   	BCLR   	GIE
   	BCLR   	KBIF
   	BSET   	KBIE
   	BCLR   	P11D
   	NOP
   	NOP
   	STOP 
   	NOP
   	NOP
   	BCLR   	KBIE
   	BCLR   	KBIF
   	BSET   	GIE
   	GOTO   	SLEEP_LOOP
   	   	
; exit point of MAIN

SYS_INIT:
   	BCLR   	GIE
   	CALL   	CLR_RAM
   	CALL   	IO_INIT
   	CALL   	TIMER0_INT_INIT
   	CALL   	TIMER1_INT_INIT
   	CALL   	KBIE_INIT      
   	BSET   	GIE
   	RETURN 	
; exit point of SYS_INIT

KBIE_INIT: 	
   	MOVAI  	0x01
   	MOVRA  	DDR1    ;P10  in
   	MOVAI  	0xfe
   	MOVRA  	PUCON   ;P10
   	MOVAI  	0x01
   	MOVRA  	KBIM    ;ʹP10ļжλ
   	RETURN 	
; exit point of KBIE_INIT

TIMER1_INT_INIT:
   	MOVAI  	0x80
   	MOVRA  	T1CR
   	CLRR   	PWMCR

   	MOVAI  	100
   	MOVRA  	T1LOAD  ;12.5us
   	BSET   	T1IE
   	RETURN 	
; exit point of TIMER1_INT_INIT

TIMER0_INT_INIT:
  
   	MOVAI  	0x05
   	MOVRA  	T0CR
   	MOVAI  	131
   	MOVRA  	T0CNT
   	BSET   	T0IE
   	RETURN 	
; exit point of TIMER0_INT_INIT

IO_INIT:   	   	   	   	
   	CLRR    P0
   	CLRR   	P1
   	CLRR   	DDR0       	   	
   	CLRR   	DDR1      ;1:input 0:output

   	MOVAI  	0xff
   	MOVRA  	PDCON
   	MOVRA  	PUCON     ;0:Effective 1:invalid
   	RETURN 	
; exit point of IO_INIT


CLR_RAM:

   	movai   0x40
   	movra   FSR
   	movai   48
   	movra   0x07
   	decr    FSR
   	clrr    INDF
   	djzr    0x07
   	goto    $-3
   	clrr    0x07
   	RETURN 	

; exit point of _CLR_RAM

   	end

