/******************************************************************************
;  *   	@ͺ				  : MC30P6080
;  *   	@             : 2021.08.04
;  *   	@˾/			  : SINOMCU-FAE
;  *   	@΢֧       : 2048615934
;  *   	@΢           : http://www.sinomcu.com/
;  *   	@Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *   	   	   	T0ʱ5sһ P10жϻ
				ѺP11ת
******************************************************************************/
 
#include "mc30p6080.h"
#include "user.h"


/************************************************
;  *    @          : CLR_RAM
;  *    @˵            : RAM
;  *    @        :
;  *    @ز        :
;  ***********************************************/
void CLR_RAM(void)
{      	       	
__asm
   	movai  	0x40
   	movra  	FSR
   	movai  	48
   	movra  	0x07
   	decr   	FSR
   	clrr   	INDF
   	djzr   	0x07
   	goto   	$-3
   	clrr   	0x07
__endasm;          	
}

/************************************************
;  *    @            : IO_Init
;  *    @˵              : IOʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void IO_Init(void)
{
   	P0 = 0x00; 	   	   	   	
   	P1 = 0x00;
   	DDR0 = 0x00;   	//1:input 0:output
   	DDR1 = 0x00;       	   	
   	PDCON = 0xff;  	//0:Effective 1:invalid
   	PUCON = 0xff;  	//0:Effective 1:invalid    	 
}
/************************************************
;  *    @            : TIMER0_INT_Init
;  *    @˵              : ʱT0
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void TIMER0_INT_Init(void)
{
   	T0CR=0x05;     //ʱΪCPUʱ    ʱ64Ƶ  1ms
   	T0CNT=131;
   	T0IE=1;
}
/************************************************
;  *    @            : TIMER1_INT_Init
;  *    @˵              : ʱT1
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void TIMER1_INT_Init(void)
{
   	T1CR=0x80;
   	PWMCR=0x00;
   	T1LOAD=100;        	   	   	//12.5us
   	T1IE=1;
}
/************************************************
;  *    @            : KBIE_Init
;  *    @˵              : ж
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void KBIE_Init(void)
{
   	DDR1 = 0x01;       	   	//P10  in
   	PUCON=0xfe;        	   	//P10 
   	KBIM=0x01;     	   	   	//ʹP10ļжλ
   	// 	KBIE=1
}
/************************************************
;  *    @            : Sys_Init
;  *    @˵              : ϵͳʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void Sys_Init(void)
{
   	GIE = 0;
   	CLR_RAM();
   	IO_Init();
   	TIMER0_INT_Init();
   	TIMER1_INT_Init();
   	KBIE_Init();
   	GIE  = 1;        
}
/************************************************
;  *    @            : main
;  *    @˵              : 
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void main (void)
{    
   	Sys_Init();
   	while(1)
   	{  	 
   	   	if(FLAG_TIMER0_5000ms)
   	   	{
   	   	   	FLAG_TIMER0_5000ms=0;
   	   	   	GIE = 0;
   	   	   	KBIF=0;
   	   	   	KBIE = 1;
   	   	   	P11D = 0;
   	   	   	Nop();
   	   	   	Nop();
   	       	Stop();
   	   	   	Nop();
   	   	   	Nop();
   	   	   	KBIE = 0;
   	   	   	KBIF = 0;
   	   	   	GIE = 1;
   	   	}  	   	
   	}   
}

/************************************************
;  *    @            : interrupt
;  *    @˵              : жϺ
;  *    @          :
;  *    @ز          :
;  ***********************************************/   
void int_isr(void)__interrupt
{
   	__asm
   	movra   _abuf
    swapar  _STATUS
    movra   _statusbuf
__endasm;

    if((T0IF)&&(T0IE))
    {
   	   	T0CNT=131;
   	   	timer0_count1++;
   	   	if(timer0_count1>=5000)
   	   	{
   	   	   	timer0_count1=0;
   	   	   	FLAG_TIMER0_5000ms=1;   	   	   	
   	   	}
   	   	T0IF=0;
    }
   	if((T1IF)&&(T1IE))
   	{
   	   	P11D=!P11D;
   	   	T1IF=0;
   	}
__asm
    swapar  _statusbuf
    movra   _STATUS
    swapr   _abuf
    swapar  _abuf
__endasm;
}


/**************************** end of file *********************************************/