;******************************************************************************
;  *   	@MCU   	   	   	   	 : MC30P6080
;  *   	@Create Date         : 2020.01.17
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@֧QQȺ   	   	  : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/   	 
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *   	   	   	   	   	T0ʱ1msһж P12ת
;  *	   	   	   	   	T1ʱ12.5usһж P11ת  	   	   	   	
;******************************************************************************

#include "MC30P6080.inc"

cblock 0x0010
abuf
statusbuf

endc

    
    org     0x03ff
   	goto    MAIN

    org	    0x8
   	GOTO   	INT_ISR
INT_ISR:
   	movra   abuf
   	swapar  STATUS
   	movra   statusbuf

   	JBSET  	T0IF
   	GOTO   	T0_END
   	JBSET  	T0IE
   	GOTO   	T0_END
    
   	MOVAI  	131
   	MOVRA  	T0CNT
    MOVAI   00000100B
    XORRA   P1      ;P12ת
   	BCLR   	T0IF
T0_END:
   	JBSET  	T1IF
   	GOTO   	T1END
   	JBSET  	T1IE
   	GOTO   	T1END
    MOVAI   00000010B
    XORRA   P1      ;P11ת
   	BCLR   	T1IF
T1END:

   	swapar 	statusbuf
   	movra  	STATUS
   	swapr  	abuf
   	swapar 	abuf
   	RETIE  	

MAIN:  	
   	CALL   	SYS_INIT

MAIN_LOOP:



   	GOTO   	MAIN_LOOP
; exit point of MAIN


SYS_INIT:  	
   	BCLR   	GIE
   	CALL   	CLR_RAM
   	CALL   	IO_INIT
   	CALL   	TIMER0_INT_INIT
   	CALL   	TIMER1_INT_INIT
   	BSET   	GIE 
   	RETURN 	
; exit point of SYS_INIT

TIMER1_INT_INIT:   	
   	MOVAI  	0x80
   	MOVRA  	T1CR
   	CLRR   	PWMCR      	   	   
   	MOVAI  	100         
   	MOVRA  	T1LOAD      ;12.5us
   	BSET   	T1IE
   	RETURN 	
; exit point of TIMER1_INT_INIT

TIMER0_INT_INIT:
   	MOVAI  	0x05
   	MOVRA  	T0CR    ;ʱΪCPUʱ    ʱ64Ƶ  1ms
   	MOVAI  	131
   	MOVRA  	T0CNT
   	BSET   	T0IE
   	RETURN 	
; exit point of TIMER0_INT_INIT

IO_INIT:   	   	   	   	   	
   	CLRR   	P0
   	CLRR   	P1
   	CLRR   	DDR0           	   	
   	CLRR   	DDR1     ;1:input 0:output
   	MOVAI  	0xff
   	MOVRA  	PDCON  	   
   	MOVRA  	PUCON    ;0:Effective 1:invalid
   	RETURN 	
; exit point of IO_INIT

CLR_RAM:   	           	
   	movai  	0x40
   	movra  	FSR
   	movai  	48
   	movra  	0x07
   	decr   	FSR
   	clrr   	INDF
   	djzr   	0x07
   	goto   	$-3
   	clrr   	0x07
   	RETURN 	
; exit point of CLR_RAM

   	end
